## mingw-w64-ispc-1.29.0-1.src.tar.zst

=== examples/cpu/amx/CMakeLists.txt ===
#
#  Copyright (c) 2025, Intel Corporation
#
#  SPDX-License-Identifier: BSD-3-Clause

#
# ispc examples: amx
#

# Check if we're on Linux x86-64 architecture
if(NOT (CMAKE_SYSTEM_NAME STREQUAL "Linux" AND (ISPC_ARCH STREQUAL "x86-64" OR CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64|AMD64")))
    message(STATUS "AMX example requires Linux x86-64 architecture. Skipping AMX example.")
    return()
endif()

# Test for __fp16 support
include(CheckCXXSourceCompiles)
check_cxx_source_compiles("
int main() {
    __fp16 a = 1.0;
    __fp16 b = 2.0;
    __fp16 c = a + b;
    return 0;
}
" HAS_FP16_SUPPORT)

if(NOT HAS_FP16_SUPPORT)
    message(STATUS "AMX example requires __fp16 support, but host compiler doesn't support it. Skipping AMX example.")
    return()
endif()

# Check for AMX hardware support on Linux
set(AMX_SUPPORTED FALSE)
set(AMX_DETECTION_METHOD "none")

# First check for hardware AMX support via CPUID
include(CheckCSourceRuns)
set(CMAKE_REQUIRED_LIBRARIES "")

check_c_source_runs("
    #include <cpuid.h>
    #include <stdio.h>

    int check_amx_tile_support() {
        unsigned int eax, ebx, ecx, edx;
        // Check CPUID.(EAX=7,ECX=0):EDX[bit 24] for AMX-TILE
        if (__get_cpuid_count(7, 0, &eax, &ebx, &ecx, &edx)) {
            return (edx & (1 << 24)) != 0;
        }
        return 0;
    }

    int check_amx_fp16_support() {
        unsigned int eax, ebx, ecx, edx;
        // Check CPUID.(EAX=7,ECX=1):EAX[bit 21] for AMX-FP16
        if (__get_cpuid_count(7, 1, &eax, &ebx, &ecx, &edx)) {
            return (eax & (1 << 21)) != 0;
        }
        return 0;
    }

    int main() {
        if (check_amx_tile_support() && check_amx_fp16_support()) {
            return 0; // Success
        }
        return 1; // Failure
    }
" HAVE_AMX_SUPPORT)

if(HAVE_AMX_SUPPORT)
    message(STATUS "Detected AMX hardware support via CPUID (AMX-TILE and AMX-FP16)")
    set(AMX_SUPPORTED TRUE)
    set(AMX_DETECTION_METHOD "hardware_cpuid")
else()
    message(STATUS "AMX hardware support not detected via CPUID")
    # Fallback to Intel SDE if hardware support is not available
    find_program(SDE_EXECUTABLE
        NAMES sde
        PATHS ENV SDE_PATH
        PATH_SUFFIXES bin
        DOC "Intel SDE (Software Development Emulator) for AMX emulation"
    )

    if(SDE_EXECUTABLE)
        message(STATUS "Found Intel SDE: ${SDE_EXECUTABLE} - will use for AMX emulation")
        set(AMX_SUPPORTED TRUE)
        set(AMX_DETECTION_METHOD "sde")
    else()
        set(AMX_SUPPORTED FALSE)
    endif()
endif()

if(NOT AMX_SUPPORTED)
    message(STATUS "Neither AMX hardware nor Intel SDE found. Skipping AMX example.")
    return()
endif()

message(STATUS "AMX support detected via: ${AMX_DETECTION_METHOD}")

if(AMX_SUPPORTED)
    set (ISPC_SRC_NAME "amx_matmul")
    set (TARGET_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/amx_matmul.cpp)
    set (ISPC_FLAGS -O2 --target=avx512gnr-x32 --enable-llvm-intrinsics --pic)
    set (ISPC_IA_TARGETS "avx512gnr-x32")

    add_ispc_example(NAME "amx"
                  ISPC_IA_TARGETS ${ISPC_IA_TARGETS}
                  ISPC_SRC_NAME ${ISPC_SRC_NAME}
                  TARGET_SOURCES ${TARGET_SOURCES}
                  ISPC_FLAGS ${ISPC_FLAGS})

    # Add compile definitions for matrix dimensions
    target_compile_definitions(amx PRIVATE
        MAT_SIZE_M=128
        MAT_SIZE_N=128
        MAT_SIZE_K=128)

    # Add SDE path if available
    if(SDE_EXECUTABLE)
        get_filename_component(SDE_PATH "${SDE_EXECUTABLE}" DIRECTORY)
        get_filename_component(SDE_PATH "${SDE_PATH}" DIRECTORY)
        target_compile_definitions(amx PRIVATE SDE_PATH="${SDE_PATH}")
    endif()

    # Handle testing when SDE emulation is required
    if(AMX_DETECTION_METHOD STREQUAL "sde")
        # Disable the default test since it cannot run on non-AMX hardware
        set_tests_properties(amx PROPERTIES DISABLED TRUE)

        # Add a new test that uses SDE emulation
        add_test(NAME amx_sde
                 COMMAND ${SDE_EXECUTABLE} -gnr -- $<TARGET_FILE:amx>
                 WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
        set_tests_properties(amx_sde PROPERTIES
            TIMEOUT 300
            LABELS "cpu_example"
        )
        message(STATUS "Test 'amx' disabled, 'amx_sde' configured to use SDE emulation")
    endif()

    # Add run target that uses the best available execution method
    if(AMX_DETECTION_METHOD STREQUAL "sde")
        # Use SDE emulation if that's how we detected support
        add_custom_target(run-amx
            COMMAND ${SDE_EXECUTABLE} -gnr -- $<TARGET_FILE:amx>
            DEPENDS amx
            COMMENT "Running AMX example with Intel SDE emulation"
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        )
        message(STATUS "Added run target: 'run-amx' (will use SDE emulation)")
    else()
        # Use native execution if we detected hardware support
        add_custom_target(run-amx
            COMMAND $<TARGET_FILE:amx>
            DEPENDS amx
            COMMENT "Running AMX example on native hardware"
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        )
        message(STATUS "Added run target: 'run-amx' (will use native hardware)")
    endif()
endif()

=== examples/xpu/simple-dpcpp/CMakeLists.txt ===
#
#  Copyright (c) 2021-2025, Intel Corporation
#
#  SPDX-License-Identifier: BSD-3-Clause

#
# ispc examples: simple-dpcpp
#

cmake_minimum_required(VERSION 3.13)

set(TEST_NAME "simple-dpcpp")
set(ISPC_SRC_NAME "simple-dpcpp.ispc")
set(ISPC_TARGET_XE "xehpg-x8")
set(DPCPP_HOST_SOURCES simple-dpcpp.cpp)

if(UNIX)
    add_perf_example(
        ISPC_SRC_NAME ${ISPC_SRC_NAME}
        TEST_NAME ${TEST_NAME}
        ISPC_TARGET_XE ${ISPC_TARGET_XE}
        DPCPP_HOST_SOURCES ${DPCPP_HOST_SOURCES}
    )
endif()

=== examples/xpu/simple/CMakeLists.txt ===
#
#  Copyright (c) 2020-2025, Intel Corporation
#
#  SPDX-License-Identifier: BSD-3-Clause

#
# ispc examples: simple
#

cmake_minimum_required(VERSION 3.13)

set(TEST_NAME "simple")
set(ISPC_SRC_NAME "simple.ispc")
set(ISPC_TARGET_XE "xehpg-x8")
set(HOST_SOURCES simple.cpp)

add_perf_example(
    ISPC_SRC_NAME ${ISPC_SRC_NAME}
    TEST_NAME ${TEST_NAME}
    ISPC_TARGET_XE ${ISPC_TARGET_XE}
    HOST_SOURCES ${HOST_SOURCES}
)

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>

_realname=ispc
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=1.29.0
pkgrel=1
pkgdesc="Compiler for high-performance SIMD programming on the CPU (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://ispc.github.io/"
msys2_repository_url="https://github.com/ispc/ispc"
license=('spdx:BSD-3-Clause')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-llvm-libs"
         "${MINGW_PACKAGE_PREFIX}-clang")
         #"${MINGW_PACKAGE_PREFIX}-spirv-llvm-translator"
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-llvm"
             "${MINGW_PACKAGE_PREFIX}-python")
             #"${MINGW_PACKAGE_PREFIX}-level-zero-headers"
             #"${MINGW_PACKAGE_PREFIX}-level-zero-loader"
source=("https://github.com/ispc/ispc/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        001-mingw-build.patch
        003-mingw-build-examples.patch)
sha256sums=('416774690e27d67f76e8a224fbb6641ddcfb7733a1a220e4cef4edca90440ae4'
            '4e5425f2066a95303467dd12dbe8515f2caa4d3d44f58e72bf54af0020524511'
            '7c718f30d96e307d050cb88e8ae75fc13e1e2bf4caadfcfc45f8f15a39a86129')

prepare() {
  cd ${srcdir}/${_realname}-${pkgver}
  patch -p1 -i ${srcdir}/001-mingw-build.patch
  patch -p1 -i ${srcdir}/003-mingw-build-examples.patch
}

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DBUILD_SHARED_LIBS=ON \
    -DISPC_STATIC_LINK=OFF \
    -DISPC_INCLUDE_EXAMPLES=OFF \
    -DPython3_EXECUTABLE=${MINGW_PREFIX}/bin/python \
    ${extra_config[@]} \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR=${pkgdir} ${MINGW_PREFIX}/bin/cmake --install .

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE.txt \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
